--
-- seasonManager
--
--
--
-- 9.12.2016
-- V0.1 by Lefthandright


seasonManager = {};
addModEventListener(seasonManager);
--function seasonManager.prerequisitesPresent(specializations)
    --return true;
--end;

function seasonManager:loadMap(name)

	g_currentMission.environment:addDayChangeListener(self);
	
	print("--- seasonManager V0.1 loaded --- (by Lefthandright)");
	
	local currentSeason;
	
	seasonManager.seasonCheck();
	seasonManager.weatherCheck();
	
end;

function seasonManager:deleteMap()
	
end;

function seasonManager:weatherCheck()

	--local savegameFolderPath = g_currentMission.missionInfo.savegameDirectory
	local savegameFolderPath = getUserProfileAppPath().."savegame"..g_currentMission.missionInfo.savegameIndex;
	local key = "careerSavegame.environment.rains.rain(0)";
	
	--if fileExists(savegameFolderPath .. '/careerSavegame.xml') then
		print("--- seasonManager: loading "..savegameFolderPath.."/careerSavegame.xml ---");
		
		local xmlFile = loadXMLFile("careerSavegame", savegameFolderPath .. "/careerSavegame.xml");
		local rainTypeId = getXMLString(xmlFile, key .. "#rainTypeId");
		local duration = getXMLFloat(xmlFile, key .. "#duration");
		local startDay = getXMLInt(xmlFile, key .. "#startDay");
		local startDayTime = getXMLFloat(xmlFile, key .. "#startDayTime");
		
		print ("--- seasonManager: next event "..rainTypeId.." ---");
		print ("--- seasonManager: duration "..duration.." ---");
		print ("--- seasonManager: day "..startDay.." ---");
		print ("--- seasonManager: time "..startDayTime.." ---");
		
	--end;
	
end;

function seasonManager:seasonCheck()
	
	local day = g_currentMission.environment.currentDay;
	
	if day % 4 == 1 then
		currentSeason = 1;
		print("--- seasonManager: Summer ---");
	end;
	
	if day % 4 == 2 then
		currentSeason = 2;
		print("--- seasonManager: Autumn ---");
	end;
	
	if day % 4 == 3 then
		currentSeason = 3;
		print("--- seasonManager: Winter ---");
	end;
	
	if day % 4 == 0 then
		currentSeason = 0;
		print("--- seasonManager: Spring ---");
	end;
	
end;

function seasonManager:createWeather()

	local day = g_currentMission.environment.currentDay;
	local hour = g_currentMission.environment.currentHour;
	local savegameFolderPath = getUserProfileAppPath().."savegame"..g_currentMission.missionInfo.savegameIndex;
	local xmlFile = loadXMLFile("careerSavegame", savegameFolderPath .. "/careerSavegame.xml");
	
	seasonManager.seasonCheck();
	
	if currentSeason == 0 then
		--print ("Spring");
		if hour > 20 then
			print ("--- seasonManager: writing weather ---");
			
			local eventDay = day + 1;
			local key = "careerSavegame.environment.rains.rain(0)";
			
			setXMLString(xmlFile, key .. "#rainTypeId", "rain");
			setXMLFloat(xmlFile, key .. "#duration", 720);
			setXMLFloat(xmlFile, key .. "#startDayTime", 540);
			setXMLInt(xmlFile, key .. "#startDay", eventDay);
			
			local eventDay = day + 2;
			local key = "careerSavegame.environment.rains.rain(1)";
			
			setXMLString(xmlFile, key .. "#rainTypeId", "hail");
			setXMLFloat(xmlFile, key .. "#duration", 720);
			setXMLFloat(xmlFile, key .. "#startDayTime", 540);
			setXMLInt(xmlFile, key .. "#startDay", eventDay);
			
			local eventDay = day + 3;
			local key = "careerSavegame.environment.rains.rain(2)";
			
			setXMLString(xmlFile, key .. "#rainTypeId", "fog");
			setXMLFloat(xmlFile, key .. "#duration", 360);
			setXMLFloat(xmlFile, key .. "#startDayTime", 1080);
			setXMLInt(xmlFile, key .. "#startDay", eventDay);
			
			
			saveXMLFile(xmlFile);
		end;
		
	end;
	
	if currentSeason == 1 then
		--print ("Summer");
		if hour > 20 then
			print ("--- seasonManager: writing weather ---");
			
			local eventDay = day;
			local key = "careerSavegame.environment.rains.rain(0)";
			
			setXMLString(xmlFile, key .. "#rainTypeId", "rain");
			setXMLFloat(xmlFile, key .. "#duration", 720);
			setXMLFloat(xmlFile, key .. "#startDayTime", 540);
			setXMLInt(xmlFile, key .. "#startDay", eventDay);
			
			local eventDay = day + 1;
			local key = "careerSavegame.environment.rains.rain(1)";
			
			setXMLString(xmlFile, key .. "#rainTypeId", "hail");
			setXMLFloat(xmlFile, key .. "#duration", 720);
			setXMLFloat(xmlFile, key .. "#startDayTime", 540);
			setXMLInt(xmlFile, key .. "#startDay", eventDay);
			
			local eventDay = day + 2;
			local key = "careerSavegame.environment.rains.rain(2)";
			
			setXMLString(xmlFile, key .. "#rainTypeId", "fog");
			setXMLFloat(xmlFile, key .. "#duration", 360);
			setXMLFloat(xmlFile, key .. "#startDayTime", 1080);
			setXMLInt(xmlFile, key .. "#startDay", eventDay);
			
			
			saveXMLFile(xmlFile);
		end;
		
	end;
	
	if currentSeason == 2 then
		--print ("Autumn");
		if hour > 20 then
			print ("--- seasonManager: writing weather ---");
			
			local eventDay = day;
			local key = "careerSavegame.environment.rains.rain(0)";
			
			setXMLString(xmlFile, key .. "#rainTypeId", "hail");
			setXMLFloat(xmlFile, key .. "#duration", 720);
			setXMLFloat(xmlFile, key .. "#startDayTime", 540);
			setXMLInt(xmlFile, key .. "#startDay", eventDay);
			
			local eventDay = day + 1;
			local key = "careerSavegame.environment.rains.rain(1)";
			
			setXMLString(xmlFile, key .. "#rainTypeId", "fog");
			setXMLFloat(xmlFile, key .. "#duration", 360);
			setXMLFloat(xmlFile, key .. "#startDayTime", 1080);
			setXMLInt(xmlFile, key .. "#startDay", eventDay);
			
			local eventDay = day + 3;
			local key = "careerSavegame.environment.rains.rain(2)";
			
			setXMLString(xmlFile, key .. "#rainTypeId", "rain");
			setXMLFloat(xmlFile, key .. "#duration", 720);
			setXMLFloat(xmlFile, key .. "#startDayTime", 540);
			setXMLInt(xmlFile, key .. "#startDay", eventDay);
			
			
			saveXMLFile(xmlFile);
		end;
		
	end;
	
	if currentSeason == 3 then
		--print ("Winter");
		if hour > 20 then
			print ("--- seasonManager: writing weather ---");
			
			local eventDay = day;
			local key = "careerSavegame.environment.rains.rain(0)";
			
			setXMLString(xmlFile, key .. "#rainTypeId", "fog");
			setXMLFloat(xmlFile, key .. "#duration", 360);
			setXMLFloat(xmlFile, key .. "#startDayTime", 1080);
			setXMLInt(xmlFile, key .. "#startDay", eventDay);
			
			local eventDay = day + 2;
			local key = "careerSavegame.environment.rains.rain(1)";
			
			setXMLString(xmlFile, key .. "#rainTypeId", "rain");
			setXMLFloat(xmlFile, key .. "#duration", 720);
			setXMLFloat(xmlFile, key .. "#startDayTime", 540);
			setXMLInt(xmlFile, key .. "#startDay", eventDay);
			
			local eventDay = day + 3;
			local key = "careerSavegame.environment.rains.rain(2)";
			
			setXMLString(xmlFile, key .. "#rainTypeId", "hail");
			setXMLFloat(xmlFile, key .. "#duration", 720);
			setXMLFloat(xmlFile, key .. "#startDayTime", 540);
			setXMLInt(xmlFile, key .. "#startDay", eventDay);
			
			
			saveXMLFile(xmlFile);
		end;
		
	end;
	
	--print ("--- seasonManager ---")

end;

function seasonManager:dayChanged()

	seasonManager.seasonCheck();
	--seasonManager.weatherCheck();
	print ("--- seasonManager: day " .. tostring(g_currentMission.environment.currentDay) .. " ---");
	
end;

function seasonManager:mouseEvent(posX, posY, isDown, isUp, button)

end;

function seasonManager:keyEvent(unicode, sym, Modifier, isDown)

end;

function seasonManager:update()
	
end;

function seasonManager:draw()

end;

g_careerScreen.saveSavegame = Utils.appendedFunction(g_careerScreen.saveSavegame, seasonManager.createWeather);